
/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.C
 * Author             : WCH
 * Version            : V1.1
 * Date               : 2017/11/18
 * Description        : GPIO ʹúGPIOжʹʾ
 *******************************************************************************/
#include "CH552.H"
#include "Main.H"
#include "Debug.H"
#include "GPIO.H"
#include "stdio.h"
#include <string.h>

#include <rtx51tny.h> /* RTX-51 tiny functions & defines      */

#pragma NOAREGS

sbit LED0 = P3 ^ 0;

/******************************************************************************/
/*       Task 0 'init':  RTX-51 tiny starts execution with task 0             */
/******************************************************************************/
void init(void) _task_ INIT
{
    CfgFsys(); // CH552ʱѡ
    mDelaymS(20);
	mInitSTDIO(); //0ʼ
    EA = 1;

//    os_create_task(USB);  /* start task 1                         */
//    os_create_task(UART);     /* start task 2                         */
	os_create_task(COMMAND);  /* start task 4                         */
//    os_delete_task(INIT);

}

/******************************************************************************/
/*    Task 1 'command':  RTX-51 tiny starts this task with os_create_task (1)    */
/******************************************************************************/
void command(void) _task_ COMMAND
{
    Port3Cfg(1, 2); // P32ģʽ
    LED0 = 0;
    while (1)
    {               /* endless loop                         */
        LED0 = ~LED0;
        os_wait(K_TMO, 100, 0);            /* wait for timeout: 5 ticks            */
        printf("LED State Change ! \n");
    }
}
